// cacheComment.js
// 11/10/25 cacheCommentExtension (9).06b mod
/****************************
// [base]
// 09/05/06 ββ.07
// kapaer
****************************/

/******** [ 設定ここから ] *********/
// セレクトボックスを選択して過去コメントを表示させる時
// プレイヤーだけ変更して、ページ遷移なしにするかどうか [true / false]
cacheCommentUsePlayerChange	= false;

// cacheCommentUsePlayerChange = trueの時に、URLのhashを変えるかどうか。
// ※あくまで目安なだけで、ブックマークに登録→次回開いても過去コメントにはなりません
cacheCommentUsePlayerChange_URL	= false;
/******** [ 設定ここまで ] *********/

// あらかじめ、ページに cacheCommentId (sm****形式のID), cacheCommentPrefix(watch/以降のURL)、cacheCommentDateが埋め込んである

cacheCommentNum = -1;
cacheCommentTimerId = 0;
isAutoSaveComment = true;
cacheCommentLastRes = 0;
cacheCommentLastGetRes = 0;
cacheCommentMaxRes = 0;
cacheCommentMode = "";
cacheCommentSaveRes="";
cacheCommentMainThreadId = "";


// コメントを保存する
// コメントサーバから返ってくるのは
// 成功時: 200 本文が"OK"
// 失敗時: 404 このとき本文は""になる
function saveCacheComment() {
	var url="http://www.nicovideo.jp/comment/cacheCommentSave";

// ページにあらかじめ埋め込んだID
//	var idParm = cacheCommentId;

// マイメモリー対策のため、ページ内JSから動画IDを取得する
// エラーになったら3秒待って再トライ
	try {
		var idParm = Video.v;
		if (typeof idParm !== "string") throw "";
	} catch(e) {
		saveCacheCommentButtonText("   ID取得中･･･ ");
		setTimeout("saveCacheComment()", 3000);
		return;
	}

// 投稿者コメントがあるかどうか
	try {
		if ($("flvplayer").GetVariable("has_owner_thread") == "1") {
			idParm += "s";
		} else {
			idParm += "z";
		}
	} catch(e) {
		idParm += "z";
	}

// 外からの引数
	idParm += cacheCommentSaveRes;

	saveCacheCommentButtonText("    保存中･･･  ");
	isAutoSaveComment = false;

	var saveCacheCommentAjax = new Ajax.Request(
			url,
			{
				method: 'get',
				parameters: idParm,
// 読み込み終了したら(エラーだろうがなんだろうが)これが呼ばれる
				onComplete: saveCacheCommentResponce
			});
	cacheCommentSaveRes="";
}

// コメント保存からの返答
function saveCacheCommentResponce(response) {
	if (response.responseText == "OK") {
		saveCacheCommentButtonText("    保存完了   ");
	} else {
		saveCacheCommentButtonText("     失敗w     ");
	}
// 成功失敗どちらにせよ、リスト更新&タイマーストップ
	getCacheCommentList();
	setTimeout("saveCacheCommentButtonText('コメ保存(Local)')", 5000);

}


function saveCacheCommentButtonText(buttonText) {
	$("saveCacheCommentButton").value = buttonText;
}


// コメントキャッシュのリストを更新
function getCacheCommentList() {
	var url="http://www.nicovideo.jp/comment/cacheCommentList.json";

	var getCacheCommentListAjax = new Ajax.Request(
			url,
			{
				method: 'get',
// ここではあらかじめ埋め込んでおいたIDを使う
// マイメモリーだとflvplayerからIDが取れないから(数字のみのマイメモリーIDになる)
				parameters: cacheCommentId,
				onComplete: getCacheCommentListResponce
			});
}

// コメントキャッシュリストの処理
function getCacheCommentListResponce(response) {
	if (response.responseText != "") {
		var cacheCommentList = eval("("+response.responseText+")");
		var dropList = $("cacheCommentDropList");
		var len;

		cacheCommentLastGetRes = cacheCommentList.item.lastRes;
		try {
			len = cacheCommentList.item.member.length;
			if (!len) throw "";
		} catch(e) {
			len = 0;
		}
		var prefolder = cacheCommentMode === "force" ? "/force/" : "/watch/";

		var str = "";
		if (len != cacheCommentNum && len != 0) {
			str += '<table border="0" cellspacing="0" cellpadding="0"><tr><td>'
			str += '<form><select id="cacheCommentForm" onChange="cacheCommentChange(this.options[this.selectedIndex].value)">\n';
			str += '<option value="' + prefolder + cacheCommentId + '">最新コメ再生</option>\n';
			for (var i = 0; i < len; i++) {
				var value = cacheCommentList.item.member[i].value;
				str += "<option" + (window.cacheCommentDate && value.match("comment_cache=[a-z]" + window.cacheCommentDate + "$") ? ' selected="selected"' : "") + 
					' value="' + prefolder + cacheCommentPrefix + value + '">' + 
					cacheCommentList.item.member[i].text.replace(/^(\d+)\.(\d+)\.(\d+)\./, "$1/$2/$3 ") + "</option>\n";
			}
			str += '<option value="/force/' + cacheCommentId + '?comment_cache=a0"' + (window.cacheCommentDate === 0 || location.href.match("comment_cache=a") ? ' selected="selected"' : "") + '>コメント無し</option>\n';
			str += "</select></form>";
			if (cacheCommentMode == "watch") {
				str += '</td><td><form action="#"><input type="button" value="千" onclick="saveCacheCommentMax(1000)" class="submit"><input type="button" value="5" onclick="saveCacheCommentMax(500)" class="submit"><input type="button" value="2" onclick="saveCacheCommentMax(200)" class="submit"></form>';
			}
			str += "</td></tr></table>";
			dropList.innerHTML = str;
		} else if (cacheCommentMode == "force") {
			str = '<form><select id="cacheCommentForm" onChange="cacheCommentChange(this.options[this.selectedIndex].value)">\n' + 
				"<option>過去のコメント</option>\n" + 
				'<option value="/force/' + cacheCommentId + '">最新コメ再生</option>\n' + 
				'<option value="/force/' + cacheCommentId + '?comment_cache=a0">コメント無し</option>\n' + 
				"</select></form>";
			dropList.innerHTML = str;
		}

		if (cacheCommentList.mode != "false" && cacheCommentMode != "force") {
			if (len != cacheCommentNum && cacheCommentNum != -1) {
				if (isAutoSaveComment)
					saveCacheCommentButtonText("自動保存完了");
				clearTimeout(cacheCommentTimerId);
			} else {
// プレイヤーから最新コメ数が取得できていたら、
// 自動保存されずにコメ受信完了と解釈してタイマー停止
				if (cacheCommentLastRes > 0) {
					clearTimeout(cacheCommentTimerId);
				} else {
					cacheCommentTimerId = setTimeout("getCacheCommentList()", 10000);
				}
			}
		}
		cacheCommentNum = len;
	}
}

// ページが読み込まれたらこれが呼ばれる
// 引数はwatchページ、cache再生、force強制再生
function startCacheComment(mode) {
	cacheCommentMode = mode;
	getCacheCommentList();
	if (mode === "watch") {
		var dropList = $("cacheCommentDropList");
		var str = '<table border="0" cellspacing="0" cellpadding="0"><tr><td><form action="#"><input type="button" value="千" onclick="saveCacheCommentMax(1000)" class="submit"><input type="button" value="5" onclick="saveCacheCommentMax(500)" class="submit"><input type="button" value="2" onclick="saveCacheCommentMax(200)" class="submit"></form></td></tr></table>';
		dropList.innerHTML = str;

		getCacheCommentNews();
		updateCacheCommentDropList();
	}
//	if (mode == "cache") {
//	}
//	if (mode == "force") {
//	}
}


// playerから、コメント数などを取得する
function getCacheCommentNews() {
	try {
		var len = Video.length;
		if (typeof len !== "number") throw "";
		var player = $("flvplayer");
		// プレイヤー(flash)が準備完了したら次へ
		if (typeof player.ext_getStatus() !== "string") throw "";
	} catch(e) {
		setTimeout("getCacheCommentNews()", 1000);
		return;
	}
	/*
	// 旧ver
	if (len >= 600) {
		cacheCommentMaxRes = 1000;
	} else if(len >= 300) {
		cacheCommentMaxRes = 500;
	} else if(len >= 60) {
		cacheCommentMaxRes = 250;
	} else {
		cacheCommentMaxRes = 100;
	}
	/*/// 新ver (100コメ / 分)
	cacheCommentMaxRes = (Math.floor(len / 60) + 1) * 100;
	//*/


	// 新プレ
	try {
		if (typeof player.ext_getComments === "function"){
			if (typeof cacheCommentMainThreadId !== "number") {
				player.ext_getThreads('cacheCommentGetThreadInfo');
			}
			if (typeof cacheCommentMainThreadId === "number") {
				var obj = player.ext_getComments(cacheCommentMainThreadId, 1);
				if (obj && obj[0]) {
					cacheCommentLastRes = obj[0]["resNo"];
				} else {
					throw "";	// コメントが0の動画の判別が不可能
//					throw "player.ext_getCommentsがおかしい";
				}
			} else {
				throw "";	// コメント受信済みの確認が不可能
//				throw "MainThreadIdエラー:数字で取得できてない";
			}
		} else {
			// 旧 & wrapper
			var nico = player.GetVariable("o");
			if (nico) {	
	//			getCacheCommentNews_old(nico);
	//			inline展開(関数分けると、ちょっとめんどかった。)
				// "base"だとwrapper
				nico = (nico === "base") ? "nico." : "";
				var last_res = player.GetVariable(nico+"last_resno");
				if (last_res == "0") last_res = player.GetVariable(nico+"last_resno_community");
				if (!last_res || last_res == "0") throw "";
				cacheCommentLastRes = last_res;
			} else {
				throw '旧プレで情報("o")が取れなかった。';
			}
		}
	} catch(e) {
		if (e) alert("cacheComment getCacheCommentNewsエラー:" + e);
		// コメントが0の時もループ対象
		setTimeout("getCacheCommentNews()", 3000);
		return;
	}
	// 無事に取得できたときは1分後に再びチェック
	setTimeout("getCacheCommentNews()", 60000);
}

function cacheCommentGetThreadInfo(param) {
	var type = 'main';
	// チャンネル
	if (window.Video.communityId) type = "private";
	for (var i = 0, l = param.length; i < l; i++) {
		if (param[i].type == type) {
			cacheCommentMainThreadId = param[i].id;
			return;
		}
	}
}
	
function getCacheCommentNews_old(nico) {
	// 削除予定
	// "base"だとwrapper
	if (nico === "base") {
		nico = "nico.";
	} else {
		nico = "";
	}
	var last_res;
	if (typeof $("flvplayer").ext_getStatus() !== "undefined") {
		try {
			// 旧プレ&wrapperは取得可能
			last_res = $("flvplayer").GetVariable(nico+"last_resno");
			if (last_res == "0") last_res = $("flvplayer").GetVariable(nico+"last_resno_community");
			if (!last_res || last_res == "0") throw "";
			cacheCommentLastRes = last_res;
			return;
		} catch(e) {
			// コメント未受信は"0"
			if (last_res != "0") alert("cacheComment getCacheCommentNews_oldエラー:" + e + ", last_res=" + last_res + ", state=" + $("flvplayer").ext_getStatus());
			setTimeout("getCacheCommentNews()", 3000);
			return;
		}
	}
}

// 新着コメント数などの表示
function updateCacheCommentDropList() {
	var mymemory;
	try {
		mymemory = $("flvplayer").GetVariable("mm");
		if (!mymemory) throw"";
	} catch(e) {
		mymemory = 0;
	}
	var dropListId = $("cacheCommentForm");
	if (cacheCommentLastRes != 0 && cacheCommentMaxRes != 0 && dropListId) {
		var newRes = cacheCommentLastRes - cacheCommentLastGetRes;
		var persent = Math.round(newRes * 100 / cacheCommentMaxRes);
		if (newRes >= 0 && mymemory == 0)
			dropListId.options[0].text =newRes+"/"+cacheCommentMaxRes+" "+persent+"%";
	}
	setTimeout("updateCacheCommentDropList()", 10000);
}

// 強制1000件保存とか
function saveCacheCommentMax(num) {
	if (!num) num = cacheCommentMaxRes || 1000;
	cacheCommentSaveRes = "&" + num;
	saveCacheComment();
}

// コメントキャッシュの削除
function removeCacheComment() {
	var removeCacheCommentAjax = new Ajax.Request(
			"http://www.nicovideo.jp/comment/removeCacheComment",
			{
				method: 'get',
				parameters: cacheCommentId + "_" + cacheCommentDate,
				onComplete: removeCacheCommentResponce
			});
}
function removeCacheCommentResponce(response) {
	if (response.responseText == "OK") {
		$("removeCacheCommentButton").value = "削除完了";
	} else {
		$("removeCacheCommentButton").value = "失敗w";
	}
// リストの更新
	getCacheCommentList();
}

// 指定された動画の全コメントキャッシュの削除
function removeAllCacheComment() {
	if (!window.confirm('この動画のコメントをすべて削除します')){
		return;
	}

	var removeAllCacheCommentAjax = new Ajax.Request(
			"http://www.nicovideo.jp/comment/removeCacheComment",
			{
				method: 'get',
				parameters: cacheCommentId,
				onComplete: removeAllCacheCommentResponce
			});
	$("removeAllCacheCommentButton").disabled = true;
}
function removeAllCacheCommentResponce(response) {
	if (response.responseText == "OK") {
		$("removeAllCacheCommentButton").value = "    削除完了   ";
	} else {
		$("removeAllCacheCommentButton").value = "     失敗w     ";
	}
// リストの更新
	getCacheCommentList();
	$("removeAllCacheCommentButton").disabled = false;
}

// 動画キャッシュのないコメントを削除
function removeCommentExistMovie() {
	if (!window.confirm('動画キャッシュのないコメントを削除します')){
		return;
	}
	var removeCommentExistMovieAjax = new Ajax.Request(
			"http://www.nicovideo.jp/comment/removeCommentExistMovie",
			{
				method: 'get',
				onComplete: removeCommentExistMovieResponce
			});
	$("removeCommentExistMovieButton").value = "    削除中･･･   ";
	$("removeCommentExistMovieButton").disabled = true;
}
function removeCommentExistMovieResponce(response) {
	if (response.responseText == "OK") {
		$("removeCommentExistMovieButton").value = "    削除完了   ";
	} else {
		$("removeCommentExistMovieButton").value = "     失敗w     ";
	}
	$("removeCommentExistMovieButton").disabled = false;
}

// 指定数以下のコメント数のキャッシュを削除
function removeShortComment() {
	var limit = $("removeShortCommentLimit").value;
	if (!window.confirm(limit+'以下のコメント数のキャッシュを削除します')){
		return;
	}
	var removeShortCommentAjax = new Ajax.Request(
			"http://www.nicovideo.jp/comment/removeShortComment",
			{
				method: 'get',
				parameters: limit,
				onComplete: removeShortCommentResponce
			});
	$("removeShortCommentButton").value = "    削除中･･･   ";
	$("removeShortCommentButton").disabled = true;
}
function removeShortCommentResponce(response) {
	if (response.responseText == "OK") {
		$("removeShortCommentButton").value = "    削除完了   ";
	} else {
		$("removeShortCommentButton").value = "     失敗w     ";
	}
	$("removeShortCommentButton").disabled = false;
}


// cacheCommentPlayerChangeがある場合、ページ更新させない
function cacheCommentChange(value){
	try{
		if (cacheCommentUsePlayerChange) {
			if (value.match(/comment_cache=([a-z])([0-9]+)/)) {
				var type = RegExp.$1;
				var time = RegExp.$2;
				var mm = cacheCommentPlayerChange.variables.mm;
				cacheCommentPlayerChange.variables.mm = 1;
				cacheCommentPlayerChange(cacheCommentPlayerChange.attributes.swf.replace(/ts=.+/, "ts=" + cacheCommentId + type + time));
				cacheCommentPlayerChange.variables.mm =mm;
				if (cacheCommentUsePlayerChange_URL) location.hash = "?comment_cache=" + type + time;
				// hashを変えているけど、そのままコピペしても意味なし。「#」をなくせばOK
				return;
			} else {
				var mm = cacheCommentPlayerChange.variables.mm;
				cacheCommentPlayerChange.variables.mm = "";
				// 最新コメ sm9z11111～は過去コメ
				cacheCommentPlayerChange(cacheCommentPlayerChange.attributes.swf.replace(/ts=[a-z]{2}[0-9].*/, "ts=" + (new Date().getTime() / 1000 | 0)));
				cacheCommentPlayerChange.variables.mm =mm;
				if (cacheCommentUsePlayerChange_URL) location.hash = "";
				return;
			}
		}
	} catch (e) {}
	location.href = value;
}


function cacheCommentPlayerChange(src, width, height, eco) {
	try {
		if (!src && cacheCommentPlayerChange.attributes) src = cacheCommentPlayerChange.attributes.swf;
		if (!src) return;
		var so1 = new SWFObject(src, "flvplayer", null, null, 9);
		so1.params = Object.extend({}, cacheCommentPlayerChange.params || window.so.params || {});
		so1.variables = Object.extend({}, cacheCommentPlayerChange.variables || window.so.variables || {});
		so1.attributes = Object.extend([], cacheCommentPlayerChange.attributes || window.so.attributes || []);
		try {
			if (!src.match(/[?]ts=/) && $("flvplayer").src.match(/([?]ts=.*)$/)) src += RegExp.$1;
		} catch (ee) {}
		if (!src.match(/[?]ts=/) && cacheCommentPlayerChange.attributes.swf.match(/([?]ts=.*)$/)) src += RegExp.$1;
		so1.setAttribute("swf", src);
		if (width) so1.setAttribute("width", width);
		if (height) so1.setAttribute("height", height);
		so1.addVariable("eco", eco ? "1" : "");
		try {
			so1.addVariable("fv_play_from", $('flvplayer').ext_getPlayheadTime());
		} catch (ee) {}
		so1.write("flvplayer_container");
		$('flvplayer_container').style.width = "auto";
		$('flvplayer_container').style.height = "auto";
		$('flvplayer_container').style.padding = "0px";
		return false;
	} catch (e) {
		alert("cacheCommentPlayerChange error : " + (e.message || e));
	}
};
({
	fn: function () {
		cacheCommentPlayerChange.params = so.params;
		cacheCommentPlayerChange.variables = so.variables;
		cacheCommentPlayerChange.attributes = so.attributes;
	},
	init: function () {
		if (typeof Nico != "undefined" && typeof Nico.onReady == "function") {
			Nico.onReady(this.fn);
		} else {
			Event.observe(window, "load", this.fn);
		}
	}
}).init();